; -----------------------------------------------------------------------------
; Pontus: The awe-striking wonder of the Sea
; (c)2020-2021 marquee design  
;
; A 128 byte wonder by superogue
;
; Greetings to: 
; sensenstahl, tomcat/abaddon, rrrola, digimind, p01, hellmood, frag, harekiet
; nuey, bruce, sjaak, sag, ile, aaldert, fready and the rest at #demotivation
;
; check out our other stuff at https://marqueedesign.revival-studios.com
; -----------------------------------------------------------------------------
%define FREEDOS

org 100h

start:
%ifndef FREEDOS
 les cx,[bx]	
%else 
 mul ax
 mov cx,0x20cd
 push word 0xa000-70
 pop es 
%endif
mov ds,cx
mov al,13h
palloop:				
 int 10h 
 sub ch,2
 dec bx
 mov ax,0x1010
loop palloop

mov cx,63
iterloop:
texture:	
  imul si,byte 117 
  jz skip
  mov al,byte [si+64]		
  adc al,byte [si+63]		
  neg al			
  shr al,1	
skip:
 mov byte [si],al
 inc si
jnz texture
loop iterloop

; ============================= UPDATE LOOP =================================
frameloop:
    %ifdef FREEDOS
 	 sub dh,104			; 3b
    %else 
	 sub dx,0x648c		;4b
    %endif
	; --- cast sea waves and caustics ---
	mov cl,64
rayloop:
	push cx
	neg cx
	and cx,63 
	movsx bx,dl
	imul bx,cx
	movsx ax,dh
	shl ax,4
	add bx,ax
	mov ax,cx
	add ax,bp	
	mov bl,al
	mov al,byte [bx]
	movsx bx,dh	
	sal bx,1
	imul bx,cx
	sub bx,bp
	add bh,60
	pop cx
	cmp al,bh
	js rc_drawpixel
	loop rayloop

rc_drawpixel:
	add ax,ax
	add ax,bp
	cbw
	xor al,ah
	shr al,3
	sub al,44
storepixel:
	stosb
	mov ax,0xcccd
	mul di	
%ifndef FREEDOS
jo frameloop		
%else
	inc di
	inc di
jnz frameloop
%endif
 inc bp
%ifndef FREEDOS
 imul ax,bp,byte 86
 aam 0xEB		; i couldn't resist ;-)
 mov dx,0x330
 out dx,al
jmp frameloop
%else
 in al,0x60
 dec al
jnz frameloop
ret
%endif
	
